import Foundation
import ArgumentParser
import TSCBasic
import TSCUtility

let keyLenght = 32
let ivLength = 16

enum OptionType: String {
    case encrypt = "e"
    case decrypt = "d"
    case unknown = "u"
    init(value: String) {
        
        if let type = OptionType.init(rawValue: value){
            self = type
        }else{
            self = .unknown
        }
    }
}

struct EncryptionTool: ParsableCommand {
    
    @Option(help: "Specify e to encrypt or d to decrypt")
    var action: String = "e"
    
    @Option(help: "Specify source key")
    var key: String?
    
    @Option(help: "Specify salt")
    var salt: String?
    
    @Option(help: "Specify full-key (Base64(KM+IVM))")
    var fullKey: String?
    
    @Argument(help: "Specify file")
    var file: String
    
    func run() throws {
        
        let comand = OptionType.init(value: action)
        
        switch comand {
        case .encrypt:
            
            do{
                try self.encryptFile(path: file)
            }catch let error{
                print("Fail encrypt file \(error)")
            }
        case .decrypt:
            do{
                try self.decryptFile(path: file)
            }catch let error{
                print("Fail decrypt file \(error)")
            }
        case .unknown:
            print("unknown parameter \"\(action)\". Specify e to encrypt or d to decrypt")
        }
    }
    
    
    func encryptFile(path:String) throws {
        
        guard let data = FileManager.default.contents(atPath: path) else {
            throw Error.noFile
        }
        
        var resKeyData:Data!
        var resIVData:Data!
        
        if let fullKey = fullKey{
            guard let fullData = Data.init(base64Encoded: fullKey) else{
                throw Error.fullKeyInvalidBase64
            }
            
            guard fullData.count == keyLenght + ivLength else {
                throw Error.fullKeyInvalidDataLength
            }
            resKeyData = fullData.subdata(in: 0..<keyLenght)
            resIVData = fullData.subdata(in: keyLenght..<keyLenght+ivLength)
            
        }else{
            
            guard let key = key, let salt = salt else {
                print("you should provide either source key and salt or full encryption data (base64 string generated by tool)")

                throw Error.noAnyKey
            }

            let sourceKeyData = Data.init(key.utf8)
            let saltData = Data.init(salt.utf8)

            resKeyData = try AES256.createKey(password: sourceKeyData, salt: saltData)
            
            let keyBase64 = resKeyData.base64EncodedString()

            print("generated key from sourceKey:\(key) salt:\(salt) -> base64:\(keyBase64)")

            resIVData = AES256.randomIv()
            
            let ivBase64 = resIVData.base64EncodedString()

            print("generated iv -> count:\(resIVData.count) base64:\(ivBase64)")

            let fullKeyData = NSMutableData()
            fullKeyData.append(resKeyData)
            fullKeyData.append(resIVData)

            let fullKeyDataString = (fullKeyData as Data).base64EncodedString()

            print("generated full encryption data base64: \(fullKeyDataString)")

        }
        
        print("get AES with key count: \(resKeyData.count), iv count: \(resIVData.count)")
        
        let aes = try AES256.init(key: resKeyData, iv: resIVData)

        let encryptedBytes = try aes.encrypt(data)
        let encryptedData = Data(encryptedBytes)
        
        let destinationPath = path.appending(".enc")
        
        let destinationURL = URL(fileURLWithPath: destinationPath)
        
        try encryptedData.write(to: destinationURL)
        
        print("The file was encrypted successfully.")
    }
    
    func decryptFile(path:String) throws {
        
        
        guard let data = FileManager.default.contents(atPath: path) else {
            throw Error.noFile
        }
        
        guard  let fullKey = fullKey else {
            throw Error.fullKeyUnspecified
        }
        
        guard  let fullData = Data.init(base64Encoded: fullKey) else {
            throw Error.fullKeyInvalidBase64
        }
        
        
        guard fullData.count == keyLenght + ivLength else {
            throw Error.fullKeyInvalidDataLength
        }
        
        let resKeyData:Data = fullData.subdata(in: 0..<keyLenght)
        let resIVData:Data = fullData.subdata(in: keyLenght..<keyLenght+ivLength)
        
        let aes = try AES256.init(key: resKeyData, iv: resIVData)
        
        let decryptedData = try aes.decrypt(data)
        
        let fileName = ((path as NSString).replacingOccurrences(of: ".enc", with: "") as NSString).lastPathComponent as NSString
        let fileExtension = (fileName as NSString).pathExtension as NSString
        let fileNameWithoutExtension = fileName.deletingPathExtension as NSString
        let fileDirectory = (path as NSString).deletingLastPathComponent as NSString
        
        
        let decryptedDestinationPath = fileDirectory.appendingPathComponent("\(fileNameWithoutExtension)_decrypted.\(fileExtension)")
        let decryptedDestionationURL = URL(fileURLWithPath: decryptedDestinationPath)
        
        try decryptedData.write(to: decryptedDestionationURL)
        
        print("The file was decrypted successfully.")
        
        
    }
}

extension EncryptionTool {
    enum Error: Swift.Error {
        case missingAllArguments
        case missingKey
        case noFile
        case noAnyKey
        case fullKeyUnspecified
        case fullKeyInvalidBase64
        case fullKeyInvalidDataLength
        case undefinedError
    }
}


extension Data {
    func subdata(in range: ClosedRange<Index>) -> Data {
        return subdata(in: range.lowerBound ..< range.upperBound + 1)
    }
}


EncryptionTool.main()

